#define FBGFX_FALLBACK

function utf(txt as string) as string
  ' translate UTF8-string to ANSI codepage 437
  dim as string ret, tempString
  dim as integer i, index, char(128 to 255) = { _
      &hC7, &hFC, &hE9, &hE2, &hE4, &hE0, &hE5, &hE7, _
      &hEA, &hEB, &hE8, &hEF, &hEE, &hEC, &hC4, &hC5, _
      &hC9, &hE6, &hC6, &hF4, &hF6, &hF2, &hFB, &hF9, _
      &hFF, &hD6, &hDC, &hA2, &hA3, &hA5, &h20A7, &h192, _
      &hE1, &hED, &hF3, &hFA, &hF1, &hD1, &hAA, &hBA, _
      &hBF, &h2310, &hAC, &hBD, &hBC, &hA1, &hAB, &hBB, _
      &h2591, &h2592, &h2593, &h2502, &h2524, &h2561, &h2562, &h2556, _
      &h2555, &h2563, &h2551, &h2557, &h255D, &h255C, &h255B, &h2510, _
      &h2514, &h2534, &h252C, &h251C, &h2500, &h253C, &h255E, &h255F, _
      &h255A, &h2554, &h2569, &h2566, &h2560, &h2550, &h256C, &h2567, _
      &h2568, &h2564, &h2565, &h2559, &h2558, &h2552, &h2553, &h256B, _
      &h256A, &h2518, &h250C, &h2588, &h2584, &h258C, &h2590, &h2580, _
      &h3B1, &hDF, &h393, &h3C0, &h3A3, &h3C3, &hB5, &h3C4, _
      &h3A6, &h398, &h3A9, &h3B4, &h221E, &h3C6, &h3B5, &h2229, _
      &h2261, &hB1, &h2265, &h2264, &h2320, &h2321, &hF7, &h2248, _
      &hB0, &h2219, &hB7, &h221A, &h207F, &hB2, &h25A0, &hA0 }
  i = 0
  do while len(txt) > i
    index = txt[i]
    if index > 223 then
      if len(txt) > i+2 then
        index = ((index and 15) shl 12) + ((txt[i+1] and 63) shl 6) + (txt[i+2] and 63)
        i += 2
      end if
    elseif index > 191 then
      if len(txt) > i+1 then
        index = ((index and 31) shl 6) + (txt[i+1] and 63)
        i += 1
      end if
    end if
    select case index
      case 32 to 127
        ret &= mid(txt, i+1, 1)
      case else
        for k as integer = 128 to 255
          if index = char(k) then
            ret &= chr(k)
            exit for
          end if
        next
    end select
    i += 1
  loop
  return ret
end function

function FT_Init_FreeType(p as any ptr) as integer
  return 0
end function

type TFT_Var
  ErrorMsg  as integer
  Library   as integer
  PixelSize as integer
end type

dim shared FT_Var as TFT_Var

type TCoord
  as integer x, y
end type

type FT_Face as integer
/'
end type '/

declare sub drawGlyph(img as FB.Image ptr, byval font as FT_Face, byval x as integer, byval y as integer, byval clr as uinteger)
declare function FTsize(byval txt as string, byval font as FT_Face, byval size as integer = 18) as TCoord
declare function getFont(byval fontName as string) as FT_Face
declare sub centerFT overload(img as FB.Image ptr, txt as string, font as FT_Face, _
                     size as integer = 18, clr as uinteger = 0)
declare sub centerFT(x as integer, y as integer, txt as string, font as FT_Face, _
                     size as integer = 18, clr as uinteger = 0)
declare function printFT overload(byval txt as string, byval font as FT_Face, _
                         byval size as integer = 18, byval clr as uinteger = 0) as FB.Image ptr
declare function printFT(byval x as integer, byval y as integer, byval txt as string, byval font as FT_Face, _
                         byval size as integer = 18, byval clr as uinteger = 0) as boolean

function FTsize(byval txt as string, byval font as FT_Face, byval size as integer = 18) as TCoord
  return type<TCoord>(len(txt)*8, 16)
end function

function getFont(byval fontName as string) as FT_Face
  return -1
end function

sub centerFT(img as FB.Image ptr, txt as string, font as FT_Face, size as integer = 18, clr as uinteger = 0)
  if img = 0 then exit sub
  dim as FB.Image ptr tempImg = printFT(txt, font, size, clr)
  dim as integer sx, sy, dx, dy, w, h
  if tempImg then
    if tempImg->width >= img->width then
      sx = 0
      dx = (tempImg->width-img->width)\2
      w  = img->width-1
    else
      sx = (img->width-tempImg->width)\2
      dx = 0
      w  = tempImg->width-1
    end if
    if tempImg->height-4 >= img->height then
      sy = 0
      dy = (tempImg->height-img->height)\2
      h  = img->height-1
    else
      sy = (img->height-tempImg->height)\2+4
      dy = 0
      h  = tempImg->height-1
    end if
    put img, (sx, sy), tempImg, (dx, dy)-step(w, h)
    imagedestroy tempImg
  end if
end sub

sub centerFT(x as integer, y as integer, txt as string, font as FT_Face, size as integer = 18, clr as uinteger = 0)
  dim as TCoord textsize = FTsize(txt, font, size)
  printFT x-textsize.x\2, y-textsize.y\2+1, txt, font, size, clr
end sub

function printFT(byval txt as string, byval font as FT_Face, _
                 byval size as integer = 18, byval clr as uinteger = 0) as FB.Image ptr
  dim as TCoord imgSize = FTsize(txt, font, size)
  dim as FB.Image ptr img = imagecreate(imgSize.x, imgSize.y, 0)
  draw string img, (0, 0), txt, not clr
  return img
end function

function printFT(byval x as integer, byval y as integer, byval txt as string, byval font as FT_Face, _
                 byval size as integer = 18, byval clr as uinteger = 0) as boolean
  if len(txt) = 0 then return true
  draw string(x, y), txt, clr
  return true
end function
