#include once "xmlparse.bi"

declare sub help(as string, as string, as integer = 24, as integer = 24, as integer = 752, as integer = 552)
declare sub helpAddHeadLevel(arr(any) as integer, as integer)
declare function helpWriteHeadLevel(arr(any) as integer) as string

sub help(helpfile as string, id as string, _
         x as integer = 24, y as integer = 24, _
         w as integer = 752, h as integer = 552)
  redim as string helpline(50)
  dim as integer curHead, countHead(1 to 6), countLines = 0, filenumber = freefile
  dim as integer fontWidth = 8, fontHeight = 18
  open helpfile for input as filenumber
  dim as TypXML xml = xmlParse(xmlParse(, filenumber).inhalt)
  close filenumber
  do while xml.tag <> "body" andalso len(xml.rest)
    xml = xmlParse(xml.rest)
  loop
  if xml.tag <> "body" then exit sub
  xml = xmlParse(xml.inhalt)
  do
    if len(xml.tag) = 2 andalso xml.tag[0] = 104 and xml.tag[1] > 48 and xml.tag[1] < 55 then
      curHead = xml.tag[1]-48
      helpAddHeadLevel countHead(), curHead
      if xml.getAttr("id") = id then
        ' found start - looking for the end
        helpLine(0) = helpWriteHeadLevel(countHead()) & " " & xml.inhalt
        xml = xmlParse(xml.rest)
        do while len(xml.tag)
          if len(xml.tag) = 2 andalso xml.tag[0] = 104 and xml.tag[1] > 48 then
            if xml.tag[1] < curHead+49 then exit do
            countLines += 1
            helpAddHeadLevel countHead(), xml.tag[1]-48
            if ubound(helpLine) < countLines then redim preserve helpLine(countLines+50)
            helpLine(countLines) = helpWriteHeadLevel(countHead()) & " " & xml.inhalt
          elseif xml.tag = "p" then
            countLines += 1
            helpLine(countLines) = xml.inhalt
          end if
          xml = xmlParse(xml.rest)
        loop
      end if
    end if
    xml = xmlParse(xml.rest)
  loop while len(xml.rest)
  ' print
  dim as integer search, xPos = 0, yPos = 0, count = 0
  dim as string tempString = utf2ansi(helpLine(0))
  cls
  do
    if len(tempString) < w\fontWidth then
      draw string (x, y+yPos), tempString
      if count >= countLines then exit do
      yPos += 2*fontHeight
      count += 1
      tempString = utf2ansi(helpLine(count))
    else
      search = instrrev(tempString, " ", w\fontWidth+1)
      if search = 0 then
        draw string (x, y+yPos), left(tempString, w\fontWidth)
        tempString = mid(tempString, w\fontWidth+1)
      else
        draw string (x, y+yPos), left(tempString, search-1)
        tempString = mid(tempString, search+1)
      end if
      yPos += fontHeight
    end if
  loop until yPos > h
  getkey
end sub

sub helpAddHeadLevel(countHead(any) as integer, level as integer)
  countHead(level) += 1
  for i as integer = level+1 to 6
    countHead(i) = 0
  next
end sub

function helpWriteHeadLevel(countHead(any) as integer) as string
  dim as string ret = str(countHead(1))
  for i as integer = 2 to 6
    if countHead(i) = 0 then exit for
    ret &= "." & countHead(i)
  next
  return ret
end function
