' module: list words and various informations (sorted) 
#include once "include/showWords.bi"

namespace DICTIONARY
  enum SORT
    word = 1, translate, id, diffWord, diffTrans, mark
    last
  end enum
  namespace OPT
    const word = 1, translate = 2, verb = 4
  end namespace
  declare function callback(exercise as TExercise) as long
  declare function outp(x as integer, y as integer, x2 as integer, h as integer, _
                        word as TWord, opt as integer) as integer
  declare function search(list as mdList(TListPoint), search as string, searchOpt as integer) as mdList(TListPoint)
  declare function settings(exercise as TExercise, optional as long = 1) as long
end namespace

globalOptions.add(TExercise("Wörterbuch", "dict", 0, @DICTIONARY.callback, 0, @DICTIONARY.settings))

function DICTIONARY.callback(exercise as TExercise) as long
  static as integer sorted = 0, searchOpt = 3, spec = 0
  static as string searchString
  dim as integer index, count, mx, my, mb, mw, wheel, wheelNew, upState, downState
  dim as integer tempInt, page = 0, direction = 1
  dim as uinteger col
  dim as string tempstring, key
  dim as TWord word
  redim as string keyArray(exercise.fullList.size-1)
  redim as TListPoint lpArray(exercise.fullList.size-1)
  enum
    posNone   = 0, posSetting, posHelp, posUp, posDown, posBack
    posSearch = 10   ' leave space for search options
    posSort   = 20   ' leave space for sort options
  end enum

  if sorted = 0 then
    cls
    exercise.fullList.list.clear
    exercise.fullList.load("default-es-de")
    listToArray exercise.fullList, "word", keyArray(), lpArray()
    quickSort keyArray(), lpArray()
    arrayToList exercise.fullList, lpArray()
    exercise.fullList.save
    exercise.currentList.list.clear
    dim as mdList(TListPoint) tempList
    tempList = search(exercise.fullList.list, searchString, searchOpt)
    exercise.currentList.list.addAll(templist)
    tempList.clear
    sorted = SORT.word
  elseif searchString = "" then
    exercise.currentList.list.addAll(exercise.fullList.list)
  end if
  count = exercise.fullList.size

  dim as integer LBx = 0, LBy = 550, LBw = 140, LBh = 30, LBpx = 20, LBpy = 10
  dim as integer SBx = 650, SBy = 50, SBw = 120, SBh = 30, SBp = 15
  dim dictGui as TGui, event as TGuiEvent
  dim as string buttonSearchInfo(1 to ...) = { "spanisch", "deutsch", "Verbform" }
  dim as TGuiButton buttonSearch(1 to ubound(buttonSearchInfo)) 
  dictGui.buttons.add _
      TGuiButton(possort+SORT.word, LBx+LBw+LBpx, LBy, LBw, LBh, "Wort spanisch", chr(255, 61))
  dictGui.buttons.add _
      TGuiButton(possort+SORT.translate, LBx+2*(LBw+LBpx), LBy, LBw, LBh, "Wort deutsch", chr(255, 62))
  dictGui.buttons.add _
      TGuiButton(possort+SORT.id, LBx+3*(LBw+LBpx), LBy, LBw, LBh, "nach Lektion", chr(255, 63))
  dictGui.buttons.add _
      TGuiButton(possort+SORT.diffWord, LBx+(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "Stand spanisch", chr(255, 64))
  dictGui.buttons.add _
      TGuiButton(possort+SORT.diffTrans, LBx+2*(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "Stand deutsch", chr(255, 65))
  dictGui.buttons.add _
      TGuiButton(possort+SORT.mark, LBx+3*(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "nach Markierung", chr(255, 66))
  dictGui.buttons.add _
      TGuiButton(posBack, LBx+4*(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "zurück", chr(27))
  dictGui.buttons.add _
      TGuiButton(posUp,      exepath & "/img/up.bmp", LBx+30, LBy, 31, 30, chr(255, 73))
  dictGui.buttons.add _
      TGuiButton(posDown,    exepath & "/img/down.bmp", LBx+70, LBy, 31, 30, chr(255, 81))
  dictGui.buttons.add _
      TGuiButton(posHelp,    exepath & "/img/help.bmp", LBx+25, LBy+40, 40, 40, chr(255, 59), "", GuiState.noBorder)
  dictGui.buttons.add _
      TGuiButton(posSetting, exepath & "/img/settings.bmp", LBx+65, LBy+40, 40, 40, chr(9), "", GuiState.noBorder)
  dictGui.buttons.add _
      TGuiButton(posSearch, SBx, SBy, SBw, SBh, "Suche", chr(255, 60))
  for i as integer = 1 to ubound(buttonSearch)
    buttonSearch(i) = TGuiButton(posSearch+i, SBx, SBy+(i+1)*(SBh+SBp), SBw, SBh, buttonSearchInfo(i))
    if bit(searchOpt, i-1) then buttonSearch(i).state or= GuiState.activated
    dictGui.buttons.add buttonSearch(i)
  next

  ' show words
  dim as TPages pages = TPages(13, 40, 15, 15, 10, 180, 500, 550, 1)
  dim as TGuiButton tempButton
  pages.outp = @outp
  pages.colWidth = pages.colDist
  pages.calcPositions(exercise.currentList.list)
  page = 0
  do
    pages.barPos = 0
    screenlock
    cls
    line (0, 0)-step(SCREEN_X-1, LBy-1), &hffffff, bf
    pages.printEntries(exercise.currentList.list, page)
    ' show arrow buttons or not?
    if pages.pages.size = 1 then
      ' hide if only one page is shown
      if upState <> GuiState.hidden then
        dim as TGuiButton tempButton = dictGui.getButton(posUp)
        tempButton.state = GuiState.hidden
        dictGui.setButton(tempButton)
        upstate = GuiState.hidden
      end if
      if downState <> GuiState.hidden then
        dim as TGuiButton tempButton = dictGui.getButton(posDown)
        tempButton.state = GuiState.hidden
        dictGui.setButton(tempButton)
        downState = GuiState.hidden
      end if
    else
      if page = 0 then
        ' deactivate "up"
        if upState <> GuiState.deactivated then
          dim as TGuiButton tempButton = dictGui.getButton(posUp)
          tempButton.state = GuiState.deactivated
          dictGui.setButton(tempButton)
          upState = GuiState.deactivated
        end if
      else
        ' activate "up"
        if upState <> GuiState.active then
          dim as TGuiButton tempButton = dictGui.getButton(posUp)
          tempButton.state = GuiState.active
          dictGui.setButton(tempButton)
          upState = GuiState.active
        end if
      end if
      if page = pages.pages.size-1 then
        ' deactivate "down"
        if downState <> GuiState.deactivated then
          dim as TGuiButton tempButton = dictGui.getButton(posDown)
          tempButton.state = GuiState.deactivated
          dictGui.setButton(tempButton)
          downState = GuiState.deactivated
        end if
      else
        ' activate "down"
        if downState <> GuiState.active then
          dim as TGuiButton tempButton = dictGui.getButton(posDown)
          tempButton.state = GuiState.active
          dictGui.setButton(tempButton)
          downState = GuiState.active
        end if
      end if
    end if
    tempButton = dictGui.getButton(posSort+sorted)
    tempButton.state = GuiState.activated
    dictGui.setButton(tempButton)
    dictGui.show
    if len(searchString) < 15 then
      centerFT SBx+SBw\2, SBy+2*SBh, searchString, font, 12
    else
      centerFT SBx+SBw\2, SBy+2*SBh, left(searchString, 12) & "...", font, 12
    end if
    screenunlock
    do
      getmouse mx, my, wheel, mb
      sleep 1
    loop until mb < 1
    ' user input
    do
      key = inkey
      event = dictGui.getEvent(key)
      ' mark / speak words / show more info
      tempInt = iif(key = "0", -1, cint(key))
      getmouse mx, my, wheelNew, mb
      if tempInt = 9 then tempInt = 0
      if tempInt orelse mb = 1 orelse mb = 2 then
        for i as integer = 0 to ubound(pages.wordPos)
          with pages.wordPos(i)
            if checkMouseIn(.x, .y-pages.wordDist\2, pages.colDist\2, .h+pages.wordDist) <> 0 then
              if tempInt then
                ' mark word
                word = globallist.get(.id)
                word.mark = iif(tempInt = -1 or word.mark = tempInt, 0, tempInt)
                globallist.put(.id, word)
                screenlock
                cls
                pages.printEntries(exercise.currentList.list, page)
                dictGui.show
                screenunlock
              elseif mb = 2 then
                ' speak word
                if spec <> 1 orelse i < pages.barPos then
                  dictGui.show GuiState.deactivated
                  speak globallist.get(.id).word
                  dictGui.show
                  exit for
                end if
              elseif mb = 1 then
                ' show info
                dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
                get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
                wordInfo globallist.get(.id)
                put (0, 0), tempImg, pset
                imagedestroy tempImg
                exit for
              end if
            end if
          end with
        next
      end if
      ' mouse wheel
      if mx >= 0 then
        if wheelNew > wheel then
          event.id = posUp
        elseif wheelNew < wheel then
          event.id = posDown
        end if
        wheel = wheelNew
      end if
      ' GUI buttons
      select case as const event.id
        case posUp
          if page > 0 then
            page -= 1
            exit do
          end if
        case posDown
          if page < pages.pages.size-1 then
            page += 1
            exit do
          end if
        case posHelp
          dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
          help LANGUAGE & "/doc.htm", "dictionary"
          put (0, 0), tempImg, pset
          imagedestroy tempImg
        case posSetting
          ' TODO
          'chooseWords(exercise)
          'list.clear
          'if exercise.currentList.size then
          '  list.addAll(exercise.currentList.list)
          '  count = exercise.currentlist.size
          'else
          '  list.addAll(exercise.fullList.list)
          '  count = exercise.fulllist.size
          'end if
          'pages.calcPositions(list)
          'page = 0
          'exit do
        case posSearch
          dim as string tempString = searchInput
          if tempString <> searchString and tempString <> chr(27) then
            searchString = tempString
            exercise.currentList.list.clear
            dim as mdList(TListPoint) tempList
            tempList = search(exercise.fullList.list, searchString, searchOpt)
            exercise.currentList.list.addAll(tempList)
            tempList.clear
            pages.calcPositions(exercise.currentList.list)
            page = 0
            exit do
          end if
        case posSearch+1 to posSearch+ubound(buttonSearch)
          buttonSearch(event.id-posSearch).state xor= GuiState.activated
          if bit(searchOpt, event.id-posSearch-1) then
            searchOpt = bitreset(searchOpt, event.id-posSearch-1)
          else
            searchOpt = bitset(searchOpt, event.id-posSearch-1)
          end if
          dictGui.setButton buttonSearch(event.id-posSearch)
          buttonSearch(event.id-posSearch).show
          exercise.currentList.list.clear
          dim as mdList(TListPoint) tempList
          tempList = search(exercise.fullList.list, searchString, searchOpt)
          exercise.currentList.list.addAll(tempList)
          tempList.clear
          pages.calcPositions(exercise.currentList.list)
          page = 0
          exit do
        case posSort+1 to posSort+SORT.last-1
          if sorted = event.id - posSort then direction *= -1 else direction = 1
          tempButton = dictGui.getButton(posSort+sorted)
          tempButton.state = GuiState.active
          dictGui.setButton(tempButton)
          tempButton.show
          sorted = event.id - posSort
          tempButton = dictGui.getButton(event.id)
          tempButton.state = GuiState.activated
          dictGui.setButton(tempButton)
          tempButton.show
          select case event.id-posSort
            case SORT.word      : tempString = "word"
            case SORT.translate : tempString = "trans"
            case SORT.id        : tempString = "id"
            case SORT.diffWord  : tempString = "levelA"
            case SORT.diffTrans : tempString = "levelB"
            case SORT.mark      : tempString = "mark"
          end select
          listToArray exercise.fullList, tempString, keyArray(), lpArray()
          quickSort keyArray(), lpArray(), direction
          arrayToList exercise.fullList, lpArray()
          exercise.currentList.list.clear
          dim as mdList(TListPoint) tempList
          tempList = search(exercise.fullList.list, searchString, searchOpt)
          exercise.currentList.list.addAll(templist)
          tempList.clear
          pages.calcPositions(exercise.currentList.list)
          page = 0
          exit do
        case posBack
          exit do, do
      end select
      sleep 1
    loop until key = chr(255, 107)
  loop until key = chr(27) or key = chr(255, 107)
  if key = chr(255, 107) then return RETVAR.windowClosed
  return RETVAR.ok
end function

function DICTIONARY.outp(x as integer, y as integer, x2 as integer, h as integer, _
                         word as TWord, optional as integer) as integer
  dim as integer col, ret = word.translate.size
  dim as string irr = replace(word.map.get("irr"), "→", "->")
  if len(irr) and ret = 1 then ret = 2
  if optional mod 32 then
    select case word.map.get("genus")
      case "m"  : col = &hff
      case "f"  : col = &hff0000
      case else : col = 0
    end select
    printFT x, y, word.word, font, optional mod 32, col
    if len(irr) then
      printFT x, y+15, "  (" & irr & ")", font, optional mod 32
      if optional mod 32 then
        dim as FB.Image ptr attImg = imagecreate(16, 16)
        bload exepath & "/img/attention.bmp", attImg
        put (x-14, y), attImg, pset
        imagedestroy attImg
      end if
    end if
    for i as integer = 0 to word.translate.size-1
      printFT x2, y+i*15, word.translate.get(i), font, optional mod 32
    next
    printFT 2*x2-x, y, "Lektion " & word.lession\100 & "." & (word.lession mod 100), font, optional mod 32
    printFT 2*x2-x+100, y, "Stand " & word.levelA & " / " & word.levelB, font, optional mod 32
    if word.mark > 0 then
      dim as FB.Image ptr markImg
      markImg = imagecreate(16, 16)
      bload exepath & "/img/" & word.mark & ".bmp", markImg
      put (x-30, y), markImg, pset
      imagedestroy markImg
    end if
  end if
  return ret*h
end function

function DICTIONARY.search(list as mdList(TListPoint), srch as string, srchOpt as integer) as mdList(TListPoint)
  dim as integer i, size = list.size*list.size-1
  dim as TListPoint lp1
  dim as TWord w1, w2
  dim as mdList(TListPoint) ret
  dim as integer found
  foreach(TListPoint, lp1, list)
    w1 = globallist.get(lp1.id)
    if len(srch) then
      found = 0
      if srchOpt and OPT.word then
        if instr(w1.word, srch) then found = -1
      end if
      if found = 0 andalso srchOpt and OPT.translate then
        for i as integer = 0 to w1.translate.size-1
          if instr(w1.translate.get(i), srch) then found = -1 : exit for
        next
      end if
      if found = 0 andalso srchOpt and OPT.verb then
        if w1.groupname = "verb" then
          for i as integer = 0 to 255
            if instr(conjugation(w1, i), srch) then found = -1 : exit for
          next
        end if
      end if
      if found = 0 then continue while
    end if
    if w1.word = "" then continue while
    ret.add(lp1)
  nexteach
  return ret
end function

function DICTIONARY.settings(exercise as TExercise, optional as long = 1) as long
  return 0
end function
