' module: list choosen words and their translation
#include once "include/showWords.bi"

declare function learning(exercise as TExercise) as long
globalExercises.add(TExercise("Wörter lernen", "full", 0, @learning, @infoEmpty, @chooseWords))

sub learningDrawAll(list as mdList(TListPoint), allPages as TPages, page as integer, gui as TGui)
  screenlock
  cls
  allPages.printEntries(list, page)
  allPages.showBar
  gui.show
  screenunlock
end sub

function learningOutput(x as integer, y as integer, x2 as integer, h as integer, _
                        word as TWord, opt as integer) as integer
  dim as integer col, ret = word.translate.size
  dim as string irr = replace(word.map.get("irr"), "→", "->")
  if len(irr) and ret = 1 then ret = 2
  if opt mod 32 then
    select case word.map.get("genus")
      case "m"  : col = &hff
      case "f"  : col = &hff0000
      case else : col = 0
    end select
    printFT x, y, word.word, font, opt mod 32, col
    if len(irr) then
      printFT x, y+15, "  (" & irr & ")", font, opt mod 32
      if opt mod 32 then
        dim as FB.Image ptr attImg = imagecreate(16, 16)
        bload exepath & "/img/attention.bmp", attImg
        put (x-14, y), attImg, pset
        imagedestroy attImg
      end if
    end if
    for i as integer = 0 to word.translate.size-1
      printFT x2, y+i*15, word.translate.get(i), font, opt mod 32
    next
    if word.mark > 0 then
      dim as FB.Image ptr markImg
      markImg = imagecreate(16, 16)
      bload exepath & "/img/" & word.mark & ".bmp", markImg
      put (x-30, y), markImg, pset
      imagedestroy markImg
    end if
  end if
  return ret*h
end function

function learning(exercise as TExercise) as long
  dim as integer index, count, mx, my, mb, mw, wheel, upState, downState
  dim as integer tempInt, page = 0
  dim as uinteger col
  static as integer spec = 0
  dim as string tempstring, key, hideTxt(2) = { "deutsch -> spanisch", "alles zeigen", "spanisch -> deutsch" }
  dim as mdList(TListPoint) list
  if exercise.currentList.size then
    list.addAll(exercise.currentList.list)
    count = exercise.currentlist.size
  else
    list.addAll(exercise.fullList.list)
    count = exercise.fulllist.size
  end if
  dim as TWord word

  enum
    posNone = 0, posSetting, posHelp, posHide, posShuffle, posBack, posUp, posDown
  end enum
  dim as integer LBx = 100, LBy = 590, LBw = 150, LBh = 30, LBp = 20
  dim learnGui as TGui, event as TGuiEvent
  learnGui.buttons.add _
      TGuiButton(posHide, LBx+LBw+LBp, LBy, LBw, LBh, hideTxt(spec), chr(255, 61))
  learnGui.buttons.add _
      TGuiButton(posShuffle, LBx+2*(LBw+LBp), LBy, LBw, LBh, "Wörter mischen", chr(255, 62))
  learnGui.buttons.add _
      TGuiButton(posBack, LBx+3*(LBw+LBp), LBy, LBw, LBh, "zurück", chr(27))
  learnGui.buttons.add _
      TGuiButton(posHelp, exepath & "/img/help.bmp", LBx+50, LBy, 40, 40, chr(255, 59), "", GuiState.noBorder)
  learnGui.buttons.add _
      TGuiButton(posSetting, exepath & "/img/settings.bmp", LBx+100, LBy, 40, 40, chr(9), "", GuiState.noBorder)
  learnGui.buttons.add _
      TGuiButton(posUp, exepath & "/img/up.bmp", LBx-60, LBy, 31, 30, chr(255, 73))
  learnGui.buttons.add _
      TGuiButton(posDown, exepath & "/img/down.bmp", LBx-20, LBy, 31, 30, chr(255, 81))

  ' show words
  dim as TPages pages = TPages(13, 40, 15, 15, 10, 180, 550, 390, 2)
  pages.outp = @learningOutput
  pages.calcPositions(list)
  page = 0
  do
    pages.barPos = 0
    screenlock
    cls
    line (0, 0)-step(SCREEN_X-1, LBy-1), &hffffff, bf
    pages.printEntries(list, page)
    ' show arrow buttons or not?
    if pages.pages.size = 1 then
      ' hide if only one page is shown
      if upState <> GuiState.hidden then
        dim as TGuiButton tempButton = learnGui.getButton(posUp)
        tempButton.state = GuiState.hidden
        learnGui.setButton(tempButton)
        upstate = GuiState.hidden
      end if
      if downState <> GuiState.hidden then
        dim as TGuiButton tempButton = learnGui.getButton(posDown)
        tempButton.state = GuiState.hidden
        learnGui.setButton(tempButton)
        downState = GuiState.hidden
      end if
    else
      if page = 0 then
        ' deactivate "up"
        if upState <> GuiState.deactivated then
          dim as TGuiButton tempButton = learnGui.getButton(posUp)
          tempButton.state = GuiState.deactivated
          learnGui.setButton(tempButton)
          upState = GuiState.deactivated
        end if
      else
        ' activate "up"
        if upState <> GuiState.active then
          dim as TGuiButton tempButton = learnGui.getButton(posUp)
          tempButton.state = GuiState.active
          learnGui.setButton(tempButton)
          upState = GuiState.active
        end if
      end if
      if page = pages.pages.size-1 then
        ' deactivate "down"
        if downState <> GuiState.deactivated then
          dim as TGuiButton tempButton = learnGui.getButton(posDown)
          tempButton.state = GuiState.deactivated
          learnGui.setButton(tempButton)
          downState = GuiState.deactivated
        end if
      else
        ' activate "down"
        if downState <> GuiState.active then
          dim as TGuiButton tempButton = learnGui.getButton(posDown)
          tempButton.state = GuiState.active
          learnGui.setButton(tempButton)
          downState = GuiState.active
        end if
      end if
    end if
    learnGui.show
    pages.showBar
    screenunlock
    do
      getmouse mx, my, wheel, mb
      sleep 1
    loop until mb < 1
    ' user input
    do
      key = inkey
      event = learnGui.getEvent(key)
      ' mouse wheel / cursor
      if getmouse(mx, my, mw, mb) then mb = 0 : mw = wheel
      if mw > wheel or key = chr(255, 72) then
        wheel = mw
        pages.moveBar -1
        learningDrawAll list, pages, page, learnGui
      elseif mw < wheel or key = chr(255, 80) then
        wheel = mw
        pages.moveBar 1
        learningDrawAll list, pages, page, learnGui
      end if
      ' mark / speak words / show more info
      tempInt = iif(key = "0", -1, cint(key))
      if tempInt = 9 then tempInt = 0
      if tempInt orelse mb = 1 orelse mb = 2 then
        for i as integer = 0 to ubound(pages.wordPos)
          with pages.wordPos(i)
            if checkMouseIn(.x, .y-pages.wordDist\2, pages.colDist\2, .h+pages.wordDist) <> 0 then
              if tempInt then
                ' mark word
                word = globallist.get(.id)
                word.mark = iif(tempInt = -1 or word.mark = tempInt, 0, tempInt)
                globallist.put(.id, word)
                screenlock
                cls
                pages.printEntries(list, page)
                pages.showBar
                learnGui.show
                screenunlock
              elseif mb = 2 then
                ' speak word
                if spec <> 1 orelse i < pages.barPos then
                  learnGui.show GuiState.deactivated
                  speak globallist.get(.id).word
                  learnGui.show
                  exit for
                end if
              elseif mb = 1 then
                ' show info
                dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
                get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
                wordInfo globallist.get(.id)
                put (0, 0), tempImg, pset
                imagedestroy tempImg
                exit for
              end if
            end if
          end with
        next
      end if
      ' GUI buttons
      select case event.id
        case posUp
          if page > 0 then
            page -= 1
            exit do
          end if
        case posDown
          if page < pages.pages.size-1 then
            page += 1
            exit do
          end if
        case posHelp
          dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
          help LANGUAGE & "/doc.htm", "learning"
          put (0, 0), tempImg, pset
          imagedestroy tempImg
        case posSetting
          tempInt = chooseWords(exercise)
          list.clear
          if exercise.currentList.size then
            list.addAll(exercise.currentList.list)
            count = exercise.currentlist.size
          else
            list.addAll(exercise.fullList.list)
            count = exercise.fulllist.size
          end if
          pages.calcPositions(list)
          page = 0
          if tempInt = RETVAR.windowClosed then key = chr(255, 107)
          exit do
        case posHide
          pages.barState = (pages.barState+1) mod 3
          learningDrawAll list, pages, page, learnGui
          dim as TGuiButton tempButton = learnGui.getButton(posHide)
          tempButton.title = hideTxt(spec)
          learnGui.setButton(tempButton)
          tempButton.show
          exit do
        case posShuffle
          for i as integer = count-1 to 0 step -1
            index = int(rnd*(i+1))
            list.add(list.get(index))
            list.remove(index)
          next
          pages.calcPositions(list)
          page = 0
          exit do
        case posBack
          exit do, do
      end select
      sleep 1
    loop until key = chr(255, 107)
  loop until key = chr(27) or key = chr(255, 107)
  if key = chr(255, 107) then return RETVAR.windowClosed
  return RETVAR.ok
end function
